> For the complete documentation index, see [llms.txt](https://docs.picketapi.com/picket-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.picketapi.com/picket-docs/reference/concepts/open-source-web3-client-libraries.md).

# Open Source Web3 Client Libraries

If you're looking to sign Picket nonces manually, leveraging open source client libraries can help you do that. This is more advanced and these are not required if you're just looking to authenticate wallets and token gate off-chain content, for that you can use a [picket library](/picket-docs/reference/libraries-and-sdks.md) for the best integration experience.

**Open Source Client Libraries for Ethereum**

* [Ethers.js](https://docs.ethers.io/v5/)
* [Web3.js](https://web3js.readthedocs.io/en/v1.7.1/)
* [Essential Eth](https://github.com/earnifi/essential-eth)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.picketapi.com/picket-docs/reference/concepts/open-source-web3-client-libraries.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
